#include "priv.h"
#include "gen.h"			//general purpose plugin Winamp
#include "resource.h"
#include "definition.h"
#include "Dlg.h"


// external declaration
extern winampGeneralPurposePlugin plugin;


#define MY_URL   _T("http://perso.club-internet.fr/boyerjl")
#define MY_EMAIL _T("mailto:boyerjl@club-internet.fr")

#define NUM_ICON 11



/* ************************************************************** */
BOOL CDlgAbout::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static HFONT hFont;
    UINT idTimer = 1;
    static UINT i;
    static HCURSOR hLinkCursor;
	static RECT rcLink, rcEmail;
	POINT pt;
	static HICON aIcon[NUM_ICON];
	static TCHAR* aIconText[NUM_ICON] = { 
		TEXT_TIPS_EXTPLAYLIST,
		TEXT_TIPS_PREVIOUSTRACK,
		TEXT_TIPS_PLAYPAUSE,
		TEXT_TIPS_STOP,
		TEXT_TIPS_NEXTTRACK,
		TEXT_TIPS_LOADFILE,
		TEXT_TIPS_VOLUME,
		TEXT_TIPS_NOTAG,
		_T("ID3v1"),
		_T("ID3v2"),
		_T("ID3v1 + ID3v2")
	};
	
    switch (uMsg) 
    {
    case WM_INITDIALOG:
		{
		HANDLE hrscHelp; 
		LPTSTR lpHelp; 
		HRSRC hrsc;
		int aIconID[NUM_ICON] = {	
							IDI_ICON1, 	IDI_ICON2, 	IDI_ICON3,
							IDI_ICON4,	IDI_ICON5,	IDI_ICON6, 
							IDI_ICON7,	IDI_ICON_ID3_0,	IDI_ICON_ID3_1,
							IDI_ICON_ID3_2,	IDI_ICON_ID3_3};

		hrsc = FindResource(plugin.hDllInstance, MAKEINTRESOURCE(IDR_DATAHELP), _T("DATAHELP") ); 
		hrscHelp = LoadResource(plugin.hDllInstance, hrsc); 
		lpHelp = (LPTSTR)LockResource(hrscHelp); 
		SetWindowText(GetDlgItem(m_hDlg, IDC_EDIT_HELP), (LPCTSTR)lpHelp);
		UnlockResource(hrscHelp); 
		FreeResource(hrscHelp); 

		hLinkCursor = LoadCursor(plugin.hDllInstance,MAKEINTRESOURCE(IDC_HYPERLINK));

		hFont = CreateFont(48, 0, 0, 0, FW_BOLD, TRUE, FALSE,0,0,0,0,0,0, _T("Arial") );
     
        for (i = 0; i<NUM_ICON; i++)
			aIcon[i] =  LoadIcon(plugin.hDllInstance, MAKEINTRESOURCE (aIconID[i]));
         
        i = 0;
        SendDlgItemMessage(m_hDlg, IDC_ANIM_ICON, STM_SETICON,(WPARAM)aIcon[i], 0);                
		SetWindowText(GetDlgItem(m_hDlg, IDC_STATIC_ICON_TEXT), (LPCTSTR)aIconText[i++]);

		SetWindowText(GetDlgItem(m_hDlg, IDC_BUTTON_HELP), (LPCTSTR)TEXT_BTN_HELP);

        SetTimer(m_hDlg, idTimer, 250, (TIMERPROC)NULL);
		}             
        return TRUE;

	case WM_PAINT:
		{
			HDC hDC;
			PAINTSTRUCT ps;
			RECT rectText;
			COLORREF OldColor;
			HFONT hOldFont;
			TCHAR szTitle[]= _T("EZ-Playlist");
			LOGFONT lf;	
			HFONT hFontHyperLink;

			hDC = BeginPaint(m_hDlg, &ps);
			
			SetBkMode(hDC, TRANSPARENT);
			GetClientRect(m_hDlg ,&rectText);
			rectText.top = 16;
			rectText.bottom = 100;
			
			hOldFont = (HFONT)SelectObject(hDC, hFont);

			// draw text in DC
			OldColor = SetTextColor(hDC,  GetSysColor( COLOR_3DHILIGHT));

			DrawText(hDC,  szTitle, _tcslen(szTitle), &rectText, DT_SINGLELINE | DT_CENTER );
			SetTextColor(hDC, GetSysColor( COLOR_3DSHADOW));
			rectText.left--;
			rectText.top--;

			DrawText(hDC,  szTitle, _tcslen(szTitle), &rectText, DT_SINGLELINE | DT_CENTER );

			// restore old text color
			SetTextColor(hDC, OldColor);
			// restore old font
			SelectObject(hDC, hOldFont);


			// Hyper Link + Email
			ZeroMemory(&lf,sizeof(lf));
			_tcscpy (lf.lfFaceName, _T("MS Sans Serif"));
			lf.lfHeight = 5;
			lf.lfWidth  = 5;
			lf.lfUnderline = TRUE;
			lf.lfOutPrecision = OUT_TT_PRECIS;
			hFontHyperLink = CreateFontIndirect ((LPLOGFONT) &lf);
			if (hFontHyperLink!=NULL) 
			{
				SIZE sSize;
				RECT rcClient;

				GetClientRect(m_hDlg, &rcClient);

				hOldFont = (HFONT)SelectObject(hDC, hFontHyperLink);
				SetBkMode(hDC,TRANSPARENT);
				SetTextAlign(hDC,TA_LEFT);
				SetTextColor(hDC,RGB(0,0,255));

				GetTextExtentPoint32(hDC,MY_URL, _tcslen(MY_URL) ,&sSize);
				rcLink.right = rcClient.right - 16; 
				rcLink.left = rcLink.right - sSize.cx;
				rcLink.bottom = rcClient.bottom - 8; 
				rcLink.top = rcLink.bottom - sSize.cy;
				TextOut(hDC,rcLink.left,rcLink.top ,MY_URL, _tcslen(MY_URL));

				GetTextExtentPoint32(hDC,MY_EMAIL, _tcslen(MY_EMAIL) ,&sSize);
				rcEmail.right = rcClient.right - 16; 
				rcEmail.left = rcEmail.right - sSize.cx;
				rcEmail.bottom = rcClient.bottom - sSize.cy - 12; 
				rcEmail.top = rcEmail.bottom - sSize.cy;
				TextOut(hDC,rcEmail.left,rcEmail.top ,MY_EMAIL, _tcslen(MY_EMAIL));

				SelectObject(hDC, hOldFont);
				DeleteObject (hFontHyperLink); 
			}


			EndPaint(m_hDlg, &ps);

		}
		return TRUE;

	case WM_LBUTTONUP:

		GetCursorPos(&pt);
		ScreenToClient(m_hDlg,&pt);

		if (PtInRect(&rcLink, pt)) 
		{
			HINSTANCE r = ShellExecute(m_hDlg,NULL, MY_URL, NULL,NULL,SW_SHOWNORMAL);
		}
		else if (PtInRect(&rcEmail, pt)) 
		{
			HINSTANCE r = ShellExecute(m_hDlg,NULL, MY_EMAIL, NULL,NULL,SW_SHOWNORMAL);
		}
		
		
		return FALSE;

	case WM_MOUSEMOVE:
		GetCursorPos(&pt);
		ScreenToClient(m_hDlg,&pt);

		if (PtInRect(&rcLink, pt) || PtInRect(&rcEmail, pt)) 
		{
			SetCursor(hLinkCursor);
			return TRUE;
		} 
		
		return FALSE;

    case WM_TIMER:
        SendDlgItemMessage(m_hDlg, IDC_ANIM_ICON, STM_SETICON,(WPARAM)aIcon[i], 0);                
		SetWindowText(GetDlgItem(m_hDlg, IDC_STATIC_ICON_TEXT), (LPCTSTR)aIconText[i++]);
        if (i == NUM_ICON)
            i = 0;
        break;                  
   
    case WM_COMMAND:
		switch (wParam) 
        {
			case IDC_BUTTON_HELP:
				ShowHelp();
				return TRUE;
			case IDOK:
			case IDCANCEL:
				EndDialog(m_hDlg,0);
				return TRUE;
        }
        break;

    case WM_DESTROY:
		if (hFont != NULL)
            DeleteObject (hFont);

        for (i=0; i<NUM_ICON; i++) 
            DeleteObject(aIcon[i]);
        KillTimer(m_hDlg, idTimer);
        return FALSE;

    }
    return FALSE;
}

/* ************************************************************** */

void CDlgAbout::ShowHelp()
{
	TCHAR szButton[40];
	BOOL bShowHelp;
	HWND hwndButton = GetDlgItem(m_hDlg, IDC_BUTTON_HELP);
	GetWindowText(hwndButton, (LPTSTR)szButton, sizeof(szButton));

	if (_tcscmp(szButton, TEXT_BTN_HELP)==0)
	{
		_tcscpy(szButton, TEXT_BTN_ABOUT);
		bShowHelp = TRUE;
	}
	else
	{
		_tcscpy(szButton, TEXT_BTN_HELP);
		bShowHelp = FALSE;
	}

	SetWindowText(hwndButton, (LPCTSTR)szButton);
	ShowWindow(GetDlgItem(m_hDlg, IDC_EDIT_HELP), bShowHelp ? SW_SHOW : SW_HIDE);			
	ShowWindow(GetDlgItem(m_hDlg, IDC_FRAME_COPYRIGHT), !bShowHelp ? SW_SHOW : SW_HIDE);			
	ShowWindow(GetDlgItem(m_hDlg, IDC_COPYRIGHT), !bShowHelp ? SW_SHOW : SW_HIDE);			
	ShowWindow(GetDlgItem(m_hDlg, IDC_COPYRIGHT2), !bShowHelp ? SW_SHOW : SW_HIDE);			

	
}
 
// //////////////////////////////
// End part for DlgAbout Dialog
// //////////////////////////////
