#include "priv.h"
#include "gen.h"			//general purpose plugin Winamp
#include "resource.h"
#include "definition.h"
#include "Dlg.h"
#include "Util.h"


extern STATGENRESTRUCT gStatGenre[ID3TAG_MAX_GENRE+2];




/* ************************************************************************ */
CDlgProperty::CDlgProperty(CDlgPlaylist* pThis, BOOL bAll): CDlg()
{
	m_pThisPlaylist = pThis;
	m_bAllPlaylist  = bAll;	
}


/* ************************************************************** */
BOOL CDlgProperty::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{

    switch (uMsg) 
    {
    case WM_INITDIALOG:
		ShowProperty();
		return TRUE;
   
    case WM_COMMAND:
		switch (wParam) 
        {
			case IDOK:
			case IDCANCEL:
				EndDialog(m_hDlg,0);
				return TRUE;
        }
        break;

    }
    return FALSE;
}

/* ************************************************************** */
void CDlgProperty::ShowProperty()
{
	CMP3Info *mp3i;
	TCHAR szTemp[100];
	TCHAR szTimeFrmt[100];
	TCHAR szProperty[32767];
	int nTotalLength = 0;
	long unsigned int uTotalFileSize = 0;
	int nAvgLength = 0;
	int nTotalFile = m_pThisPlaylist->m_minfo.GetCount();
	int ModeCount[4] = {0,0,0,0};
	int ID3Count[4] = {0,0,0,0};
	float AvgFileSize = 0;
	
	typedef struct StatSortGenre_tag
	{
		int idGenre;
		int count;
	} STATSORTGENRE;
	
	STATSORTGENRE StatSortGenre[ID3TAG_MAX_GENRE+2];

	int i,j;
	HWND hwndList = m_pThisPlaylist->m_hwndList;
	int nSelCount = ListView_GetSelectedCount(hwndList);

	LVITEM lvi; 


#define SEPARATOR(x)                 \
	_tcscat(szProperty, _T("________________________________________________\r\n")); \
	_tcscat(szProperty, _T(x));      \
	_tcscat(szProperty, _T("\r\n")); \
	
	szTemp[0] = '\0';
	szTimeFrmt[0] = '\0';


	if (m_bAllPlaylist == TRUE)
	{
		for (i=0; i<nTotalFile; i++)
		{
			mp3i = m_pThisPlaylist->m_minfo.GetInfo(i);

			if (!mp3i)	continue;

			nTotalLength += mp3i->GetPlayLength();
			uTotalFileSize += (mp3i->GetFileSize() / 1024);
			ModeCount[mp3i->GetMode()]++;
			ID3Count[mp3i->GetTagVersion()]++;
		}
	}
	else
	{
		ZeroMemory(&lvi, sizeof(lvi)); 
		lvi.mask      = LVIF_STATE | LVIF_PARAM; 
		lvi.stateMask = LVIS_SELECTED; 
		
		for (i = 0; i< nTotalFile; i++)
		{
			lvi.iItem  = i;
			ListView_GetItem(hwndList, &lvi);
			mp3i = (CMP3Info *)lvi.lParam;

			if (!mp3i) continue;

			if ((lvi.state & LVIS_SELECTED)== LVIS_SELECTED)
			{
				nTotalLength += mp3i->GetPlayLength();
				uTotalFileSize += (mp3i->GetFileSize() / 1024);
				ModeCount[mp3i->GetMode()]++;
				ID3Count[mp3i->GetTagVersion()]++;
			}
			
		}

		nTotalFile = nSelCount;

	}

	nAvgLength  = (nTotalFile == 0 ?  0 : nTotalLength / nTotalFile);
	AvgFileSize = (nTotalFile == 0 ?  0 : uTotalFileSize / nTotalFile);
	
	
// ///////////////////////////
// GENERAL INFORMATION PLAYLIST
// ///////////////////////////
	_tcscpy(szProperty, _T("GENERAL\r\n"));

	// Total Files, size
	_stprintf(szTemp, TEXT_PROPERTY_GENERAL_TOTLAFILE,
		nTotalFile, (float)uTotalFileSize/1024, (float)AvgFileSize/1024);	
	_tcscat(szProperty, szTemp);	

	// Length Total & Avg 
	Time2Str(nTotalLength, &szTimeFrmt[0], FALSE);
	_stprintf(szTemp, TEXT_PROPERTY_GENERAL_TOTALLENGTH, szTimeFrmt);
	_tcscat(szProperty, szTemp);	
	Time2Str(nAvgLength, &szTimeFrmt[0], TRUE);
	_stprintf(szTemp, TEXT_PROPERTY_GENERAL_AVGLENGTH, szTimeFrmt);
	_tcscat(szProperty, szTemp);	

// ///////////////////////////	
// ID3Tag
// ///////////////////////////
	SEPARATOR("ID3TAG");
	_stprintf(szTemp, TEXT_PROPERTY_ID3TAG, 
		ID3Count[0], ID3Count[1], ID3Count[2], ID3Count[3]);
	_tcscat(szProperty, szTemp);	
	
// ///////////////////////////
// GENRE
// ///////////////////////////
	if (m_bAllPlaylist == TRUE)
	{
		SEPARATOR("GENRE")

		// Recopie StatSortGenre
		for (j = 0, i=0; i<ID3TAG_MAX_GENRE+2; i++)
		{
			if (gStatGenre[i].nCount > 0)
			{
				StatSortGenre[j].idGenre = i;
				StatSortGenre[j].count = gStatGenre[i].nCount;
				j++;
			}
		}

		// Sort Array 
		for (i=0; i<j; i++)
		{	for (int k=i; k<j; k++)
			{
				if (StatSortGenre[k].count  > StatSortGenre[i].count )
				{
					int idGenreTmp = StatSortGenre[k].idGenre;
					int countTmp   = StatSortGenre[k].count;
					StatSortGenre[k] = StatSortGenre[i];
					StatSortGenre[i].idGenre  = idGenreTmp;
					StatSortGenre[i].count = countTmp;
				}
			}
		}

		for (i=0; i<j; i++)
		{	_stprintf(szTemp, _T("\t%-d:\t%s\r\n"), 
				StatSortGenre[i].count, GenreInt2Str((unsigned char)StatSortGenre[i].idGenre) );
			_tcscat(szProperty, szTemp);
		}
	}
	
// ///////////////////////////
// MODE
// ///////////////////////////
	SEPARATOR("MODE")
	for (i = 0; i<NUMELEMENTS(ModeCount); i++)
	{
		_stprintf(szTemp, _T("\t%-d:\t%s\r\n"), ModeCount[i], ModeName[i]);
		_tcscat(szProperty, szTemp);
		
	}
	

// ///////////////////////////
// ARTIST
// ///////////////////////////
	m_StrArray.clear();
	tstring str;

	if (m_bAllPlaylist == TRUE)
	{
		// Scan all playlist  from memory 
		for (i=0; i < m_pThisPlaylist->m_minfo.GetCount(); i++)
		{
			mp3i = m_pThisPlaylist->m_minfo.GetInfo(i);
			m_pThisPlaylist->GetFrameInfo(mp3i, ID3TAG_TPE1, str);
			if (str.empty() == FALSE)
				AddVector(str);
		}
	}
	else
	{
		ZeroMemory(&lvi, sizeof(lvi)); 
		lvi.mask      = LVIF_STATE | LVIF_PARAM; 
		lvi.stateMask = LVIS_SELECTED; 
		
		for (i = 0; i< m_pThisPlaylist->m_minfo.GetCount(); i++)
		{
			lvi.iItem  = i;
			ListView_GetItem(hwndList, &lvi);
			
			mp3i = (CMP3Info *)lvi.lParam;

			if (!mp3i) continue;

			if ((lvi.state & LVIS_SELECTED)== LVIS_SELECTED)
			{
				m_pThisPlaylist->GetFrameInfo(mp3i, ID3TAG_TPE1, str);
				if (str.empty() == FALSE)
					AddVector(str);
			}		
		}

	}

	SEPARATOR("ARTIST")

	int nCount = m_StrArray.size();
	for (i=0; i < nCount; i++)
	{
		szTemp[0] = '\0';
		_stprintf(szTemp, _T("\t%s\r\n"), m_StrArray[i].c_str());
		_tcscat(szProperty, szTemp);
	}

	m_StrArray.clear();

// ///////////////////////////
// Show  result
// ///////////////////////////
	SetWindowText(GetDlgItem(m_hDlg, IDC_EDIT_PROPERTY), szProperty);





	if (m_bAllPlaylist==FALSE)
		SetWindowText(m_hDlg, TEXT_TITLE_INFOPLAYLIST);
	

#undef SEPARATOR

}

/* ************************************************************** */
int CDlgProperty::AddVector(tstring& str)
{
	// add into the array. since this is sorted, find the right place for the insertion
	int pos = FindVector(str);
	
	switch(pos)
	{
		case -2:	// existe deja pas d'ajout
			return pos;
		
		case -1:	// ajoute a la fin
			m_StrArray.push_back(str);
			pos = m_StrArray.size()-1;
			break;
		default:	// ajoute juste apres
			m_StrArray.insert(&m_StrArray.at(pos), str);
			break;
	}

	return pos;
}

/* ************************************************************** */
/**
 * find the string which is greater than the current Array
 * this is used, to maintain a sorted list
 * returns -1 if no bigger info is found
 */
int CDlgProperty::FindVector(tstring& str)
{
	for (int i=0; i<m_StrArray.size(); i++)
	{
		int ret = m_StrArray[i].compare(str);
		
		if (ret > 0)
			return(i);			
		else if (ret == 0)
			return -2;			// Existe deja
	}
	return -1;
}

 
// //////////////////////////////
// End part for DlgProperty Dialog
// //////////////////////////////
