#include "priv.h"

#include "resource.h"
#include "definition.h"
#include "Dlg.h"

// external declaration
extern INITSTRUCT gParam;
extern COLUMNSSTRUCT gDefault_column[COLUMN_MAX];
extern TEMPLATESTRUCT gaTemplateDefault[MAX_TEMPLATE];


/* ************************************************************************ */
BOOL CDlgReset::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		return FALSE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDOK:
			{
				int ret = ResetSettings();
				EndDialog(m_hDlg, ret);
				return TRUE;
			}

		case IDCANCEL:
			EndDialog(m_hDlg, 0);
			return TRUE;

		
		}
		
	}
	return FALSE;
}


/* ************************************************************** */
int CDlgReset::ResetSettings()
{
	int bSave = 0;
	int i, j;
	
	if (IsDlgButtonChecked(m_hDlg, IDC_RESET_CSS) == BST_CHECKED)
	{
		bSave = 1;

		for (i=0; i<MAX_TEMPLATE; i++)
		{
			gParam.Template[i].cLinkColor = gaTemplateDefault[i].cLinkColor;

			for (j=0;j<MAX_CSS;j++)
			{
				gParam.Template[i].css[j].cColor     = gaTemplateDefault[i].css[j].cColor;
				gParam.Template[i].css[j].cColorBack = gaTemplateDefault[i].css[j].cColorBack;
				gParam.Template[i].css[j].nFontName  = gaTemplateDefault[i].css[j].nFontName; 
				gParam.Template[i].css[j].nFontStyle = gaTemplateDefault[i].css[j].nFontStyle;
				gParam.Template[i].css[j].nFontSize  = gaTemplateDefault[i].css[j].nFontSize;
			}
		}
	}

	if (IsDlgButtonChecked(m_hDlg, IDC_RESET_COLUMNS) == BST_CHECKED)
	{
		bSave = 1;

		gParam.sort_reverse = 0;
		gParam.sort_column  = 0;
		gParam.bShowNumber  = 0;
		gParam.bShowGrid    = 0;
		gParam.nShowID3v1   = 0;
		
		for (i=0; i<COLUMN_MAX; i++)
		{
			gParam.column_order[i] = gDefault_column[i].nOrder;
			gParam.column_width[i] = gDefault_column[i].nWidth;
			gParam.column_shown[i] = gDefault_column[i].nShown;
		}
	}

	if (IsDlgButtonChecked(m_hDlg, IDC_RESET_ID3TOOLS) == BST_CHECKED)
	{
		bSave = 1;

		for (i = 0; i <MAX_COL_FRMT; i++)	
			gParam.FrmtCol[i] = i;
	

		gParam.nMassCheckTAG     = 0;
		gParam.nMassTagID3       = 3;
		gParam.nWriteTagfromFile = 3;
		gParam.nRenameFileFromTagWithID3v1 = 1;
		_tcscpy(gParam.szSep, _T(" - "));
	}


	if (IsDlgButtonChecked(m_hDlg, 	IDC_RESET_OPTION) == BST_CHECKED)
	{
		bSave = 1;

		gParam.bExportAllItems	  = 0;
		gParam.bExportHTML_Format =	0;
		gParam.bExportHTML_Link   = 0;
		gParam.nOptionSearch      = 31;
		gParam.nDblClic           = 0;
		gParam.nOnStartup         = 0;
	}


	if (bSave)
	{
		if (MessageBox(m_hDlg, TEXT_RESETDEFAULT, TEXT_QUESTION, MB_OKCANCEL|MB_ICONQUESTION) == IDOK)
			bSave = 1;
		else
			bSave = 0;
	}
	
	return bSave;
}




// //////////////////////////////
// End part for DlgReset Dialog
// //////////////////////////////