/*****************************************************************************
    This file is part of MP3ext.
    Copyright (C) 1999  Michael Mutschler

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    email: michael@mutschler.de
******************************************************************************/
/* This file defines some things about the fields used in the ID3V2 header
 *
 * you can include this file multiple times, to get the right array
 *
 * define ID3V2_CREATE_ERROR_ARRAY 1
 *    creates the ID3V2ErrorStrings array
 *
 * if none of the above are defined, then the enumed-list is generated
 */


#ifdef ID3V2_CREATE_ERROR_ARRAY

#define ID3V2ERR(code,string)	string ,
const char * const ID3V2ErrorStrings[] = {

#else

extern const char * const ID3V2ErrorStrings[];
#define ID3V2ERR(code,string)	code ,
typedef enum {

#endif /* ID3V2_CREATE_TAG_ARRAY */


ID3V2ERR(ID3V2_ERR_OK,			"No Error")
ID3V2ERR(ID3V2_ERR_NOTYET,		"Not implemented yet")
ID3V2ERR(ID3V2_ERR_NOMEM,		"Out of Memory")
ID3V2ERR(ID3V2_ERR_NOID3V2,	"No ID3V2 Tag found")
ID3V2ERR(ID3V2_ERR_FILE,		"Cannot open file")
ID3V2ERR(ID3V2_ERR_READ,		"Reading file failed")
ID3V2ERR(ID3V2_ERR_WRITE,		"Writing file failed")
ID3V2ERR(ID3V2_ERR_FRAME,		"Tag Identifier Error")
ID3V2ERR(ID3V2_ERR_NOFRAME,	"No more Frames in Header")
ID3V2ERR(ID3V2_ERR_CORRUPT,	"ID3 Frame corrupt")
ID3V2ERR(ID3V2_ERR_BUFTOOSMALL,"Internal Error: Buffer too small")
ID3V2ERR(ID3V2_ERR_BUF,			"Error reading Tag. Tag corrupt")
ID3V2ERR(ID3V2_ERR_ENCODING,	"Unsupported string-encoding found")
ID3V2ERR(ID3V2_ERR_DELETE,		"Failed to delete original File")
ID3V2ERR(ID3V2_ERR_MOVE,		"Failed to move temporary file into old position")
ID3V2ERR(ID3V2_ERR_OLDSIZE,	"Old Tag is not big enough")

// my private return codes
ID3V2ERR(ID3V2_ERR_FIELDRANGE,"String out of range")

/* this must be the last field, to know how long the array is */
ID3V2ERR(ID3V2_NUMERR,	NULL)
};


#undef ID3V2ERR

