/*****************************************************************************
    This file is part of MP3ext.
    Copyright (C) 1999  Michael Mutschler

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    email: michael@mutschler.de
******************************************************************************/
// MP3MultiInfo.cpp: implementation of the MP3MultiInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "priv.h"
#include "MP3MultiInfo.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifndef BOOL
typedef int BOOL;
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

#pragma intrinsic(strlen, strcat)

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MP3MultiInfo::MP3MultiInfo()
{
	ResetList();
}

MP3MultiInfo::~MP3MultiInfo()
{
	ResetList();
}

void MP3MultiInfo::DeleteInfo(int index)
{
	// remove MP3info's
	delete GetInfo(index);

	// remove from array
	MP3InfoArray.erase(MP3InfoArray.begin() + index);
}

void MP3MultiInfo::ResetList()
{
	// remove all the MP3Info's
	for (int i=0; i<MP3InfoArray.size(); i++)
		delete GetInfo(i);

	if (MP3InfoArray.size() > 0)
		MP3InfoArray.erase(MP3InfoArray.begin(), MP3InfoArray.end());
}


int MP3MultiInfo::ReplaceInfo(int index, CMP3Info *mp3i)
{
	if (MP3InfoArray[index]) delete MP3InfoArray[index];
	MP3InfoArray[index] = mp3i;
	return(index);
}


int MP3MultiInfo::FindInfo(CMP3Info *mp3i)
{
	for (int i=0; i<MP3InfoArray.size(); i++)
	{
		if (MP3InfoArray[i] == mp3i)
			return(i);
	}
	return -1;
}

int MP3MultiInfo::AddInfo(CMP3Info *mp3i)
{
	MP3InfoArray.push_back(mp3i);
	int pos = MP3InfoArray.size()-1;
	return(pos);
}
