/*****************************************************************************
    This file is part of MP3ext.
    Copyright (C) 1999  Michael Mutschler

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    email: michael@mutschler.de
******************************************************************************/
// MP3MultiInfo.h: interface for the MP3MultiInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MP3MULTIINFO_H__F5F94643_30F2_11D1_AF88_080000051171__INCLUDED_)
#define AFX_MP3MULTIINFO_H__F5F94643_30F2_11D1_AF88_080000051171__INCLUDED_

#include "priv.h"
#include "MP3Info.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class MP3MultiInfo  
{
public:
	MP3MultiInfo();	// set here the size of the array
	virtual ~MP3MultiInfo();

private:
	typedef vector<CMP3Info *> MArray;
	MArray MP3InfoArray;

public:
	// functions to access the array
	void DeleteInfo(int index);
	void ResetList();
	int AddInfo(CMP3Info *mp3i);		// true if anything changed
	int ReplaceInfo(int index, CMP3Info *mp3i);
	CMP3Info *GetInfo(int index) {return(index<MP3InfoArray.size()?MP3InfoArray[index]:NULL);};
	CMP3Info * operator [] (int index) {return(GetInfo(index));};
	int FindInfo(CMP3Info *mp3i);

public:
	int GetCount() {return MP3InfoArray.size();};

};



#endif // !defined(AFX_MP3MULTIINFO_H__F5F94643_30F2_11D1_AF88_080000051171__INCLUDED_)
