/*****************************************************************************
    This file is part of MP3ext.
    Copyright (C) 1999  Michael Mutschler

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    email: michael@mutschler.de
******************************************************************************/
// Misc Functions, no classes

#ifndef _MP3PICFRAME_H
#define _MP3PICFRAME_H 1

#include "priv.h"
#include "MP3Frame.h"
#include "MP3PicFrame.h"

/* define a picture-subclass
 */

// icon-mime-type
#define MIMEICO _T("image/ico")

// the types of Pics:
#define APICTYPE_ICON 0x02

// CMP3MStringFrame is a frame for storing multiple strings, seperated by a '\0'.
class CMP3PicFrame: public CMP3Frame
{
private:

public:
// overwritten Methods:
	CMP3PicFrame(int ID, int SubID);
	~CMP3PicFrame();

	int SetID3v2Buffer(LPBUF buf, int length, int version);	// buffer is initialized
	int GetID3v2Length();								// return the size of the buffer
	int GetID3v2Buffer(LPBUF buf, int size);	// fill in a supplied buffer
	CMP3Frame *Clone();
	void appendInfo(tstring& str, int max);	// get information about the frame
	BOOL IsDefault();
	void operator = (CMP3Frame &mp3f);
	BOOL operator == (CMP3Frame &mp3f);

	tstring& getPicFormat() {return(picFormat);}
	int getPicType()		{return(getSubID());}
	LPBUF getPicData()	{return(picData);}
	int getPicDataLength() {return(picDataLength);}
	bool loadFile(LPCTSTR filename);		// load the file into the frame, and set the data

	int setData(LPCTSTR format, LPBUF data, int dataLength);	// set the actual picture data
//	int setType(int newtype);	// set new type; returns old type
	void setDescription(tstring& desc) {description = desc;}

// New Methods
private:
	tstring description;
//	int picType;
	tstring picFormat;				// mime-type of the image
	int picDataLength;
	LPBUF picData;
	int picBufferLength;		// allocated size of the buffer
};

#endif
