// systray.c
#include "priv.h"
#include <windows.h>
#include <tchar.h>

#define SYSTRAY_ICON_BASE 1024

BOOL systray_add(HWND hwnd, UINT uID, HICON hIcon, LPTSTR lpszTip);
BOOL systray_del(HWND hwnd, UINT uID);

BOOL systray_add(HWND hwnd, UINT uID, HICON hIcon, LPTSTR lpszTip)
{
  NOTIFYICONDATA tnid;

  ZeroMemory(&tnid, sizeof(tnid));

  tnid.cbSize = sizeof(NOTIFYICONDATA);
  tnid.hWnd = hwnd;
  tnid.uID = uID+SYSTRAY_ICON_BASE;
  tnid.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;
  tnid.uCallbackMessage = WM_USER + 27;
  tnid.hIcon = hIcon;
  _tcsncpy(tnid.szTip,lpszTip,sizeof(tnid.szTip)-1);
  return (Shell_NotifyIcon(NIM_ADD, &tnid));
}

BOOL systray_del(HWND hwnd, UINT uID) 
{
  NOTIFYICONDATA tnid;
  
  ZeroMemory(&tnid, sizeof(tnid));

  tnid.cbSize = sizeof(NOTIFYICONDATA);
  tnid.hWnd = hwnd;
  tnid.uID = uID+SYSTRAY_ICON_BASE;
  return(Shell_NotifyIcon(NIM_DELETE, &tnid));
}