//*******************************************************************************************
//
// Filename : definition.h
//	
//				
//
// Copyright (c) 2000 JL BOYER for EZPlaylist 
//
// (Plug in general purpose for WinAMP >2.0x)
//
//*******************************************************************************************


#include "mpg123.h"

#ifndef _DEFINITION_H
#define _DEFINITION_H

// Definition structures TAG.

#define COLUMN_MAX 16

#define MAX_COL_FRMT 6

#define MAX_TEMPLATE 8
#define MAX_CSS 4


typedef struct  tag_css
{
	COLORREF cColor; // Text color 
	COLORREF cColorBack; // background color
	int nFontName;
	int nFontStyle;
	int nFontSize;
} CSSSTRUCT;


typedef struct  tag_templatehtml
{
	CSSSTRUCT css[MAX_CSS];	// Class Style Sheet
	COLORREF cLinkColor;	// hyperlink color
} TEMPLATESTRUCT;



typedef struct  tag_myparam
{
	BOOL bExportAllItems;	// Option export, 0: All items, 1: Only selected items
	BOOL bExportHTML_Format;// Option HTML format, 0:Table, 1:Listing
	BOOL bExportHTML_Link;	// Option HTML hyperlink, 0:No hyperlink, 1:add hyperlink 
	BOOL bExportBothID3;	// Option 0:Export ID3v1 or ID3v1, 1: Export both ID3v1 and ID3v2
	BOOL bShowNumber;		// Show number in playlist, 0: No number, 1:Show number
	BOOL bShowGrid;			// Show grid in playlist, 0: No grid, 1:Show grid
	int nOptionSearch;		// Option search 1:Artist, 2:Title...  32:Case sensitive mode
	int nDblClic;			// Dbl clic 0:Play with Winamp, 1: Enqueue Winamp, 2:Edit Tag
	int nShowID3v1;			// indique si on affiche 0:ID3v1 ou 1:ID3v2
	int nOnStartup;			// 0:EZPlaylist EZ3, 1:Load Winamp
	int nMassCheckTAG;		// Check option zone Mass TAG (1:Artist, 2:Title, 4:Album...)
	int nMassTagID3;		// Mass Tag option,     0:None, 1:ID3v1, 2:ID3v2, 3:ID3v1+ID3v2
	int nWriteTagfromFile;	// Write tag from file, 0:None, 1:ID3v1, 2:ID3v2, 3:ID3v1+ID3v2
	int nRenameFileFromTagWithID3v1;	// Rename file from 1: ID3v1 or 2:ID3v2 Tag
	int FrmtCol[MAX_COL_FRMT];
	int NbCol;
	int nMatchTime;
	int nOptionCapitalize;	// 0:Unchanged ,1:All lowercase , 2:All uppercase 3:First letter of section uppercase, 4:First letter of each word uppercase
	int nOptionConvert;		// 0:No convert ,1:Underscore to space, 2:Space to underscore
//	int UseCol[COLUMN_MAX];
//	int UseColWidth[COLUMN_MAX];

	int nOrganizeFromID3;
	int nOrganizeField;

	int      column_order[COLUMN_MAX];
	int      column_shown[COLUMN_MAX];
	int      column_width[COLUMN_MAX];
    int      sort_column;
    BOOL     sort_reverse;

	
	int nCurrentTemplate;
	TEMPLATESTRUCT Template[MAX_TEMPLATE];

	char szSep[4];
	int x;					// Restoring Window Position 
	int y;
	int width;
	int height;

} INITSTRUCT;




typedef struct tag_statgenre
{
	BOOL bCheck;
	int nCount;
} STATGENRESTRUCT;



typedef struct tag_columns
{
	TCHAR szName[20];
	int nOrder;
	int nShown;
	int nWidth;
	int nAlignment;
	int nID3;
} COLUMNSSTRUCT;

typedef struct tag_ez3_header
{
	TCHAR tag[8];
	int nCountFile;
} EZ3HEADER;

typedef struct tag_ez3_headermp3info
{
	int nCountFrame;
	int tagVersion;
	int mp3size;
	int diffsize;
	int nLenFilename;
	struct mpg123info coreMP3;
	
} EZ3HEADERMP3INFO;


typedef struct tag_ez3_headerframeinfo
{
	int fid;
	int size;
} EZ3HEADERFRAME;


#endif

