#include "priv.h"

#include <commctrl.h>
#include <mmsystem.h> 	// winmm.lib. VolumeGetValue
#include "gen.h"
#include "resource.h"
#include "Volume.h"

// internal function
long VolumeGetValue(void);

// external declaration
extern winampGeneralPurposePlugin plugin;
extern HWND ghWndVolume; 


/* ************************************************************ */
void VolumeInit(HWND hwnd, HWND hWndSlider)
{
	// Initialize Volume 
	long nVol;

	SendMessage( hWndSlider, TBM_SETRANGE, TRUE, MAKELONG(0,255));
	nVol = VolumeGetValue();
	SendMessage( hWndSlider, TBM_SETPOS, TRUE, nVol);
	SendMessage( hWndSlider, TBM_SETPAGESIZE, 0L, 50L);
	SendMessage( hWndSlider, TBM_SETLINESIZE, 0L, 10L);

	VolumeSlider(hwnd, hWndSlider, FALSE); 
}

/* ************************************************************ */
void VolumeSlider(HWND hwnd, HWND hWndSlider, BOOL bSetVolWinamp) 
{
	TCHAR szLabel[80];
	int nPos;
	
	nPos = (int)SendMessage(hWndSlider, TBM_GETPOS, 0,0);
	
	if (bSetVolWinamp==TRUE)
		SendMessage(plugin.hwndParent, WM_USER, (WPARAM)nPos, 122);
	
	_stprintf(szLabel, TEXT_VOLUME_VALUE, (int)(100*nPos)/255);
	SetWindowText(GetDlgItem(hwnd, IDC_STATIC_VOLUME), szLabel);
}



/* ************************************************************ */
long VolumeGetValue(void)
{  
	UINT uDevId, uDevNum; 
	WAVEOUTCAPS  woc; 
	MMRESULT mmr;
    
	// How to Use Wave Audio Volume Control APIs
	// Last reviewed: March 12, 1997
	// Article ID: Q139098 (MSDN libray Visula Studio 6.0)
    uDevNum = waveOutGetNumDevs();
    
    for( uDevId = 0; uDevId< uDevNum; uDevId++)
   	{
    	mmr = waveOutGetDevCaps(uDevId, &woc, sizeof(woc)); 
		if (woc.dwSupport & WAVECAPS_VOLUME)
		{
			DWORD dwVolume;
			DWORD dwVol;

			waveOutGetVolume( (HWAVEOUT)uDevId, &dwVolume);

			if (dwVolume == 0xFFFFFFFF)
				dwVol = 255/2+1;	// Si pas trouve 50% volume
			else
			{	
				dwVol = LOWORD(dwVolume);
				dwVol *= 255;
				dwVol = dwVol / 65535;
			}
			
	       	return ((long)dwVol);
     	}
  
	}   
	return (0L);
}
